/* NAME: Kirill Vasil'evich Timofeev, 322
 * ASGN: N1
 */
#ifndef LOGIC_H
#define LOGIC_H

 #include <QMainWindow>

class QFile;

class Logic: public QObject
{
    Q_OBJECT

public:
    QPixmap *image;
    QImage *curImage;
    QFile *inFile;
    QFile *outFile;
    int *curHist;
    struct model* myModel;
    std::vector< std::vector<double> > trainFeatures;
    std::vector<int> trainLabels;
    QString *curFile;
    QString curInFile;
    QString curModelFile;
    QString curOutFile;
    QString curCat;

    explicit Logic();
    ~Logic();

    void getFilesTr();
    void getFileNameFromInt(int);
    void useImage(int);
    char* PRcount();
    void getFilesSDir();
    void getFilesSImg();

private:
    void trainModel(const bool);
    bool testModel();
    void makeHOG(const int, const int, const int, const int);
    void paint(const int, const int, const int, const int);
    void makeModel();
    void wash(int** , int**, int** ,int, int, int, int, int, int**, bool);

};


#endif // LOGIC_H
