/* NAME: Kirill Vasil'evich Timofeev, 322
 * ASGN: N1
 */
#ifndef CONTROLLER_H
#define CONTROLLER_H

#include <QWidget>
#include "Logic.h"
#include "mainwindow.h"


class QAction;

class Controller : public QWidget
{
    Q_OBJECT

    Logic logic;

    QString msg1;
    QString msg2;
    QString msg3;
    QString msg4;

    QAction *useAct;
    QAction *PRAct;
    QAction *trainAct;
    QAction *retrainAct;
    QAction *serImAct;
    QAction *serDirAct;
    QAction *exitAct;

public:
    MainWindow mainWin;

    explicit Controller();
    ~Controller();

    void createActions();
    void deleteActions();
    void search(bool);

private slots:
    void training();
    void usingModel();
    void serIn();
    void serDir();
    void exit();
    void files(const bool , const bool , const bool, const bool);
    void PRcount();

};

#endif // CONTROLLER_H
