/* NAME: Kirill Vasil'evich Timofeev, 322
 * ASGN: N1
 */
#include <QtGui>

#include "mainwindow.h"

MainWindow::MainWindow()
{
    window = new QWidget;
    mainLayout= new QVBoxLayout;
    labelIm = new QLabel;
    layout1 = new QHBoxLayout;
    layout2 = new QHBoxLayout;
    button0 = new QPushButton("&Use Previous Model");
    button1 = new QPushButton("&Train");
    button2 = new QPushButton("&Searching in the directory");
    button3 = new QPushButton("&Searching in an image");
    button4 = new QPushButton("&Exit");
    button5 = new QPushButton("&Retrain");
    button6 = new QPushButton("&Precision and Recall");


    layout2->addWidget(button0, 8);
    layout2->addWidget(button1, 8);
    layout2->addWidget(button6, 8);
    layout2->addWidget(button4, 8);
    layout1->addWidget(labelIm);
    mainLayout->addLayout(layout2);
    mainLayout->addLayout(layout1);
    window->setLayout(mainLayout);
    setCentralWidget(window);

    createStatusBar();
}

MainWindow::~MainWindow()
{
    delete button0;
    delete button1;
    delete button2;
    delete button3;
    delete button4;
    delete button5;
    delete button6;
    delete labelIm;
    delete layout1;
    delete layout2;
    delete mainLayout;
    delete window;

}

void MainWindow::menu2()
{
    layout2->removeWidget(button0);
    layout2->removeWidget(button1);
    layout2->removeWidget(button4);
    layout2->removeWidget(button6);
    layout2->addWidget(button2, 8);
    layout2->addWidget(button3, 8);
    layout2->addWidget(button5, 8);
    layout2->addWidget(button6, 8);
    layout2->addWidget(button4, 8);

}

void MainWindow::mesBox(char *temp)
{
    QMessageBox msgBox;
    msgBox.setWindowTitle("Message");
    msgBox.setText(temp);
    msgBox.exec();
}

QString MainWindow::message(QString msg, bool fil)
{
    QMessageBox msgBox;
    msgBox.setWindowTitle("Message");
    msgBox.setText(msg);
    msgBox.exec();
    QString newStr;
    do
    {
        if (fil) newStr = QFileDialog::getOpenFileName(this);
        else newStr = QFileDialog::getExistingDirectory(this);
    }
    while (newStr.isEmpty());

    return newStr;
}

void MainWindow::exit()
{
    QMessageBox msgBox;
    msgBox.setWindowTitle("Exit");
    msgBox.setText("Thank you for using my Program)) Goodbye!!");
    msgBox.exec();
    close();
}

void MainWindow::createStatusBar()
{
    statusBar()->showMessage(tr("Ready"));
}
